#include "camera.h"

Camera3D::Camera3D(Vector3D position, Matrix3x3 transitionMatrix)
{
   this->position = position;
   this->transitionMatrix = transitionMatrix;
   transitionMatrixTranspose = transitionMatrix.transpose(); // It's handy not to have to keep generating this.
}

Vector3D Camera3D::toCameraSpace(Vector3D argument)
{
   Vector3D answer = transitionMatrix * (argument - position);
   return answer;
}

Vector3D Camera3D::fromCameraSpace(Vector3D argument)
{
   Vector3D answer = transitionMatrixTranspose * argument + position;
   return answer;
}
