#if !defined(CYLINDER_H)
#define CYLINDER_H

#include "primitive.h"
#include "vector3d.h"
#include "rgbcolour.h"

class Cylinder : public Primitive
{
private:
   float radius, length;
   Vector3D bottom, xAxis, yAxis, zAxis; // x,y,zAxis make up a matrix which represents the rotation of the cylinder from the cylinder with world z-axis as its principle axis.
public:
   Cylinder(float radius, float length, Vector3D bottom, Vector3D xAxis, Vector3D yAxis, Vector3D zAxis, RGBColour *texture, int textureWidth, int textureHeight, int specularExponent = 0, float specularReflectivity = 0);
   float get_t(Ray ray);
   RGBColour getColour(Vector3D intersection);
   Vector3D getNormal(Vector3D intersection);
};

#endif
