#if !defined(DISC_H)
#define DISC_H

#include "primitive.h"
#include "vector3d.h"
#include "rgbcolour.h"

class Disc : public Primitive
{
private:
   Vector3D normal, uAxis, vAxis, centre;
   float uRadius, vRadius;
   int textureUCentre, textureVCentre, discUSize, discVSize;
public:
   Disc(float uRadius, float vRadius, Vector3D centre, Vector3D normal, Vector3D uAxis, int textureUCentre, int textureVCentre, int discUSize, int discVSize, RGBColour *texture, int textureWidth, int textureHeight, int specularExponent = 0, float specularReflectivity = 0);
   float get_t(Ray ray);
   RGBColour getColour(Vector3D intersection);
   Vector3D getNormal(Vector3D intersection);
};

#endif
