#if !defined(ELLIPSOID_H)
#define ELLIPSOID_H

#include "primitive.h"
#include "vector3d.h"
#include "matrix3x3.h"
#include "rgbcolour.h"

class Ellipsoid : public Primitive
{
private:
   float xRadius, yRadius, zRadius;
   Vector3D centre;
   Matrix3x3 transitionMatrix;
   Matrix3x3 transitionMatrixTranspose; // It's handy not to have to keep generating this.
public:
   Ellipsoid(float xRadius, float yRadius, float zRadius, Vector3D centre, Matrix3x3 transitionMatrix, RGBColour *texture, int textureWidth, int textureHeight, int specularExponent = 0, float specularReflectivity = 0);
   float get_t(Ray ray);
   RGBColour getColour(Vector3D intersection);
   Vector3D getNormal(Vector3D intersection);
};

#endif
