#if !defined(MATRIX3X3_H)
#define MATRIX3X3_H

#include "vector3d.h"

class Matrix3x3
{
private:
   static const int size = 3; // Somehow, I think it's nicer to have a const instead of a literal 3 everywhere, even though it's a 3x3 matrix class.
public:
   float data[size][size];
   Matrix3x3(float *data);
   Matrix3x3(Vector3D row1, Vector3D row2, Vector3D row3);
   Matrix3x3(float psi = 0.0, float theta = 0.0, float phi = 0.0); // Allow initialisation to an orthogonal matrix using Euler's angles.
   Matrix3x3 operator*(Matrix3x3 argument);
   Vector3D operator*(Vector3D argument);
   Matrix3x3 transpose();
};

#endif
