#include "misc.h"
#include <cmath>

int round(float argument)
{
   return (int) floor(argument + 0.5);
}

float iTan(float X, float Y) // A better version of atan2.
{
   if(X > 0 && Y >= 0) return atan(Y / X);
   if(X > 0 && Y < 0) return 2 * PI + atan(Y / X);
   if(X < 0) return PI + atan(Y / X);
   if(X == 0 && Y > 0) return PI / 2;
   if(X == 0 && Y < 0) return 3 * PI / 2;
   if(X == 0 && Y == 0) return 0; // This should never happen if it's given the right arguments.
   return 0; // It will never get here, but this stops a compiler warning.
}

float min(float a, float b)
{
   return a < b ? a : b; // NB: This is better than using a function macro (ie: #define etc.)
}

void sPutDW(unsigned char *string, unsigned int n)
{
   string[0] = (unsigned char) (n & 0xFF);
   string[1] = (unsigned char) ((n & 0xFF00) >> 8);
   string[2] = (unsigned char) ((n & 0xFF0000) >> 16);
   string[3] = (unsigned char) ((n & 0xFF000000) >> 24);
   return;
}

int sameSign(float a, float b)
{ // Regards 0.0 as both positive and negative.
   if(a == 0.0) return 1;
   if(a > 0.0)
   {
      if(b >= 0.0) return 1;
      return 0;
   }
   if(b <= 0.0) return 1;
   return 0;
}
