#if !defined(PRIMITIVE_H)
#define PRIMITIVE_H

#include "rgbcolour.h"
#include "vector3d.h"
#include "lightsource.h"
#include "ray.h"

class Primitive
{
public:
   RGBColour *texture;
   int textureWidth, textureHeight, specularExponent;
   float diffuseReflectivity, specularReflectivity;
   static const int nointersection_t_Value = -1; // -1 is okay, because we'd never want to consider a point behind the source.
   Primitive(RGBColour *texture, int textureWidth, int textureHeight, int specularExponent = 0, float specularReflectivity = 0);
   virtual float get_t(Ray ray) = 0;
   virtual RGBColour getColour(Vector3D intersection) = 0;
   virtual Vector3D getNormal(Vector3D intersection) = 0;
   RGBColour getLocalLight(Vector3D intersection, Vector3D viewDirection, LightSource light);
};

#endif
