#include "rgbcolour.h"

RGBColour::RGBColour(float r, float g, float b)
{
   this->r = r;
   this->g = g;
   this->b = b;
}

RGBColour RGBColour::operator+(RGBColour c)
{
   RGBColour result(r + c.r, g + c.g, b + c.b);
   if(result.r > 1.0f) result.r = 1.0f;
   if(result.g > 1.0f) result.g = 1.0f;
   if(result.b > 1.0f) result.b = 1.0f;
   return result;
}

void RGBColour::operator+=(RGBColour c)
{
   r += c.r;
   g += c.g;
   b += c.b;
   if(r > 1.0f) r = 1.0f;
   if(r > 1.0f) r = 1.0f;
   if(r > 1.0f) r = 1.0f;
   return;
}

RGBColour RGBColour::operator*(float f)
{
   RGBColour result(r * f, g * f, b * f);
   if(result.r > 1.0f) result.r = 1.0f;
   if(result.g > 1.0f) result.g = 1.0f;
   if(result.b > 1.0f) result.b = 1.0f;
   return result;
}

RGBColour RGBColour::operator*(RGBColour c)
{
   RGBColour result(r * c.r, g * c.g, b * c.b);
   if(result.r > 1.0f) result.r = 1.0f;
   if(result.g > 1.0f) result.g = 1.0f;
   if(result.b > 1.0f) result.b = 1.0f;
   return result;
}
