#if !defined(SCENE_H)
#define SCENE_H

#include "primitive.h"
#include "ray.h"
#include "rgbcolour.h"
#include "vector3d.h"
#include "lightsource.h"

class Scene
{
public:
   static const int maxRecursionLevel = 5, maxLightSources = 100, maxPrimitives = 100;
   int recursionLevel, nLightSources, nPrimitives;
   Primitive *(primitives[maxPrimitives]); // () not actually necessary.
   LightSource *(lightSources[maxLightSources]); // () not actually necessary.
   RGBColour ambientLight;

   Scene(RGBColour ambientLight);
   int addPrimitive(Primitive *p);
   int addLightSource(LightSource *l);
   float get_t(Ray ray, Primitive*& Obj);
   RGBColour doLighting(Vector3D intersection, Vector3D rayDirection, Primitive &Obj);
   int isOccluded(Vector3D p, LightSource l);
};

#endif
