#include "screen.h"
#include <cmath>

Screen::Screen(int screenWidth, int screenHeight, RGBColour background, float FOV)
{
   this->screenWidth = screenWidth;
   this->screenHeight = screenHeight;
   this->FOV = FOV;
   screenCameraDistance = sqrt(screenWidth * screenWidth + screenHeight * screenHeight) / (2 * tan(FOV / 2));
   // I should really put in exception handling for the memory allocation below.
   image = new RGBColour[screenWidth * screenHeight];
   for(int i = 0; i < screenWidth * screenHeight; i++) image[i] = background;
}

Screen::~Screen()
{
   delete [] image;
}

void Screen::putPixel(int x, int y, RGBColour pixelColour)
{
   image[x + y * screenWidth] = pixelColour;
}
