#if !defined(TRIANGLE_H)
#define TRIANGLE_H

#include "primitive.h"
#include "vector3d.h"
#include "rgbcolour.h"

class Triangle : public Primitive
{
private:
   Vector3D vertex1, vertex2, vertex3, normal;
   int textureIndexU1, textureIndexV1;
   int textureIndexU2, textureIndexV2;
   int textureIndexU3, textureIndexV3;
   int sign123, sign231, sign312;
   int inside(Vector3D point);
   int lineSide(Vector3D point, Vector3D linePoint1, Vector3D linePoint2);
public:
   Triangle(Vector3D vertex1, Vector3D vertex2, Vector3D vertex3, int textureIndexU1, int textureIndexV1, int textureIndexU2, int textureIndexV2, int textureIndexU3, int textureIndexV3, RGBColour *texture, int textureWidth, int textureHeight, int specularExponent = 0, float specularReflectivity = 0);
   float get_t(Ray ray);
   RGBColour getColour(Vector3D intersection);
   Vector3D getNormal(Vector3D intersection);
};

#endif
