#include "vector3d.h"
#include <cmath>

Vector3D::Vector3D(float x, float y, float z)
{
   this->x = x;
   this->y = y;
   this->z = z;
}

Vector3D Vector3D::operator*(float scalar)
{
   Vector3D result(x * scalar, y * scalar, z * scalar);
   return result;
}

Vector3D Vector3D::operator+(Vector3D argument)
{
   Vector3D result(x + argument.x, y + argument.y, z + argument.z);
   return result;
}

Vector3D Vector3D::operator-(Vector3D argument)
{
   Vector3D result(x - argument.x, y - argument.y, z - argument.z);
   return result;
}

float Vector3D::dot(Vector3D argument)
{
   return x * argument.x + y * argument.y + z * argument.z;
}

Vector3D Vector3D::cross(Vector3D argument)
{
   Vector3D result(y * argument.z - z * argument.y, z * argument.x - x * argument.z, x * argument.y - y * argument.x);
   return result;
}

float Vector3D::length()
{
   return sqrt(x * x + y * y + z * z);
}

void Vector3D::normalise()
{
   float l = length();
   x /= l;
   y /= l;
   z /= l;
}
